# Pipeline for source injection on CSST images

## Installation
1. First make sure CSST simulation package is installed
2. Install the source injection packages:
```
    python setup.py install --user
 ```

## Usage
### Run L1 Detrending pipeline (optional)
* If the L1 images are not available, we need first to run the CSST detrending pipeline on the raw images to get the L1 calibrated products. Otherwise this step can be ignored.
* This step removes all the instrumental related effects as well as cosmoic rays
* modify the corresponding ```config_detrending.yaml``` file to configure all running options
```
    python ./measurement_pipeline/run_csst_msc_instrument.py /path/to/config_detrending.yaml
```

### Run Source Injection
* Inject souces onto the L1 (detrended)
* modify the corresponding ```config_injection.yaml``` file to configure all running options
```
    python ./injection_pipeline/injection_pipeline.py /path/to/config_injection.yaml
```

### Run L1 Detection & Photometry pipeline
* Re-detect and redo the photometry measurements on the injected images
* modify the corresponding ```config_photometry.yaml``` file to configure all running options
```
    python ./measurement_pipeline/run_csst_msc_mbi_photometry.py /path/to/config_photometry.yaml
```

### Evaluation
* ```evaluation```package provided tools and example notebooks for evaluating:
    * Injected objects
    * Detection completeness
    * Photometric accuracy